Subject: bug#38181: Actual height of mode-line not taken into account

From: Eli Zaretskii <[email-masked]>
Date: Fri, 15 Nov 2019 15:48:53 +0200

> From: Jonas Bernoulli <[email-masked]>
> Date: Tue, 12 Nov 2019 17:52:59 +0100
> 
> If the height of the mode-line is increased by inserting an image into
> it, then that height is not taken into account in a buffer/window until
> `redisplay' has been called at least once since the buffer was created.

AFAIR, the mode line display is done lazily, because otherwise the
mode line would flicker.  When you change the face, that triggers a
thorough redisplay, because any change in faces does that (it could
mean many faces now have a different appearance).  Adding an image to
the mode line doesn't have that effect, which is why you need to force
redisplay manually.

So much for theory.  Now for the practical aspects: how bad is it to
have to invoke redisplay by hand in these cases?  After all, they
don't sound like something a Lisp program would do frequently.